<template>
   <section>
    <div class="container">
      <div class="row">
            <div class="shadow col-12 mt-4 p-3 mb-5 bg-white rounded">
                <div class="float-left">
                    <a href="javascript:window.history.go(-1);"><i class="material-icons">arrow_back_ios</i> Regresar</a>
                </div>
                <h2 class="text-center">Docentes</h2>
            </div>
        </div>

        <div class="row shadow" style="border-radius: 5px">
                <div v-if="docentes.length === 0">
                   <div class="alert alert-danger" role="alert" v-if="docentes.length === 0">
                        <h2 class="lead">No se cuenta con Docentes registrados</h2>
                    </div>
                </div>
        </div>
        <div class="row align-items-start">
            <b-button variant="primary" size="lg" id="show-btn" @click="showModal('modal-registrar')" v-b-tooltip.hover title="Registro nuevo"><i class="material-icons">person_add</i></b-button>
        </div><br>
        <div class="row shadow-lg">
        <table v-show="docentes.length > 0" class="table table-hover table-light">
            <thead>
                <tr style="background-color: #019979">
                <th scope="col" class="text-white lead">Nombre completo</th>
                <th scope="col" class="text-white lead">Correo Institucional</th>
                <th scope="col" class="text-white lead">Cédula</th>
                <th scope="col" class="text-white lead">CURP</th>
                <th scope="col" class="text-white lead text-center">ACCIONES</th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="(docente, index) in docentes" :key="index" class="table-light lead">
                <td>{{docente.nombre}} {{docente.primerApellido}} {{docente.segundoApellido}}</td>
                <td>{{docente.correoInstitucional}}</td>
                <td>{{docente.cedula}}</td>
                <td>{{docente.curp}}</td>
          
                <td>
                  <b-button variant="info" id="show-btn" style="margin-right:20px;" @click="showModal('modal-vermas'); llenarObjetoDocente(docente)" v-b-tooltip.hover title="Ver información"><i class="material-icons">visibility</i></b-button>
                  <b-button variant="warning" id="show-btn" style="margin-right:20px;" @click="showModal('modal-modificar');llenarObjetoDocente(docente)" v-b-tooltip.hover title="Modificar información" ><i class="material-icons">edit</i></b-button>
                  <b-button variant="danger" id="show-btn" @click="eliminar(docente.id)" v-b-tooltip.hover title="Eliminar registro"><i class="material-icons">delete</i></b-button>
                </td>
                </tr>
            </tbody>
        </table>
        </div>
        <div class="row">
            <div class="shadow col-12 mt-4 p-3 mb-5 bg-white rounded">
                <div class="float-left">
                </div>
                <h2 class="text-center">Docentes Carrera</h2>
            </div>
        </div>
        <div class="row">
          <div class="col-md-6">
            <div class="card">
              <div class="card-body">
                <h5 class="card-title">Debe seleccionar una carrera</h5>
                  <b-form @change="listasMateriass">
                      <div class="row form-group">
                          <div class="col">
                              <label for>Carreras</label>
                              <b-form-select v-model="carreraId" class="form-control" required>
                                  <option v-for="(carrera,index) in carreras" :key="index" :value="carrera.id">
                                      {{carrera.nombreCarrera}}
                                  </option>
                              </b-form-select>
                          </div>
                      </div>
                  </b-form>
              </div>
            </div>
          </div>

          <div class="col-md-6" v-show="carreraId > 0">
            <div class="card">
              <div class="card-body">
                <h5 class="card-title">Seleccione los datos necesarios</h5>
                <b-form @submit="registrarAsignacion">
                <div class="row form-group">
                    <div class="col">
                        <label for>Docente:</label>
                        <b-form-select v-model="docenteId" class="form-control">
                            <option v-for="(docente,index) in listasDocentes" :key="index" :value="docente.id">
                                {{docente.nombre}} {{docente.primerApellido}} {{docente.segundoApellido}}
                            </option>
                        </b-form-select>
                    </div>
                    <div class="col">
                        <label for>Materia:</label>
                        <b-form-select v-model="materiaId" class="form-control">
                            <option v-for="(materia,index) in materiasss" :key="index" :value="materia.id">
                                {{materia.nombreMateria}}
                            </option>
                        </b-form-select>
                    </div>
                </div>
                    <b-button type="submit" block variant="outline-success">Asignar</b-button>
              </b-form>
              </div>
            </div>
          </div>

        </div>
        <div>
            
        </div>
        <div class="row shadow" style="border-radius: 5px">
            <div v-if="asignaciones.length === 0">
                <div class="alert alert-danger" role="alert" v-if="asignaciones.length === 0">
                    <h2 class="lead">No cuenta con Docentes asignados</h2>
                </div>
            </div>
        </div>
        <div class="row shadow-lg">
        <table v-show="asignaciones.length > 0" class="table table-hover table-light">
            <thead>
                <tr style="background-color: #019979">
                <!-- <th scope="col">#</th> -->
                <th scope="col" class="text-white lead">Docente</th>
                <th scope="col" class="text-white lead">Materia</th>
                <th scope="col" class="text-white lead">Acciones</th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="(asignacion, index) in asignaciones" :key="index" class="table-light lead">
                <!-- <th scope="row">{{index}}</th> -->
                <td>{{asignacion.nombre}} {{asignacion.primerApellido}} {{asignacion.segundoApellido}}</td>
                <td>{{asignacion.nombreMateria}}</td>
                <td>
                  <b-button variant="warning" id="show-btn" style="margin-right:20px;"  v-b-tooltip.hover title="Modificar información"  @click="showModal('modal-modificarA');llenarObjAsignacion(asignacion)"><i class="material-icons">edit</i></b-button>
                  <b-button variant="danger" id="show-btn" v-b-tooltip.hover title="Eliminar registro" @click="eliminarAsignacion(asignacion.id)"><i class="material-icons">delete</i></b-button>
                </td>
                </tr>
            </tbody>
        </table>
        </div>
<!-- DOCENTES GRUPO -->
      <div class="row">
            <div class="shadow col-12 mt-4 p-3 mb-5 bg-white rounded">
                <div class="float-left">
                </div>
                <h2 class="text-center">Docentes Grupo</h2>
            </div>
        </div>
        <div class="row">
          <div class="col-md-6">
            <div class="card">
              <div class="card-body">
                <h5 class="card-title">Debe seleccionar una carrera</h5>
                  <b-form @change="listasGrupoProfesor">
                      <div class="row form-group">
                          <div class="col">
                              <label for>Carreras</label>
                              <b-form-select v-model="carreraIdGrupo" class="form-control">
                                  <option v-for="(carrera,index) in carreras" :key="index" :value="carrera.id">
                                      {{carrera.nombreCarrera}}
                                  </option>
                              </b-form-select>
                          </div>
                      </div>
                  </b-form>
              </div>
            </div>
          </div>
        <div class="col-md-6" v-show="carreraIdGrupo > 0">
            <div class="card">
              <div class="card-body">
                <h5 class="card-title">Seleccione los datos necesarios</h5>
                <b-form @submit="asignacionDocenteGrupo">
                <div class="row form-group">
                    <div class="col">
                        <label for>Docente:</label>
                        <b-form-select v-model="docenteIdGrupo" class="form-control" >
                            <option v-for="(docente,index) in docentesGrupo" :key="index" :value="docente.id">
                                {{docente.nombre}} {{docente.primerApellido}} {{docente.segundoApellido}}
                            </option>
                        </b-form-select>
                    </div>
                    <div class="col">
                        <label for>Grupo:</label>
                        <b-form-select v-model="idGrupoGrupo" class="form-control">
                            <option v-for="(grupo,index) in grupos" :key="index" :value="grupo.id">
                                {{grupo.gradoGrupo}} {{grupo.letraGrupo}}
                            </option>
                        </b-form-select>
                    </div>
                    <div class="col">
                        <label for>Horario:</label>
                        <b-form-select v-model="horarioId" class="form-control">
                            <option v-for="(horario,index) in horarios" :key="index" :value="horario.id">
                                {{horario.horaInicio}} - {{horario.horaFin}}
                            </option>
                        </b-form-select>
                    </div>
                </div>
                    <b-button type="submit" block variant="outline-success">Asignar</b-button>
            </b-form>
              </div>
            </div>
          </div>
        </div>
        <div class="row shadow" style="border-radius: 5px">
                <div v-if="gruposDocentes.length === 0">
                   <div class="alert alert-danger" role="alert" v-if="gruposDocentes.length === 0">
                        <h2 class="lead">No se cuenta con asignaciones registradas</h2>
                    </div>
                </div>
        </div>
        <div class="row shadow-lg">
        <table v-show="gruposDocentes.length > 0" class="table table-hover table-light">
            <thead>
                <tr style="background-color: #019979">
                <th scope="col" class="text-white lead">DOCENTE</th>
                <th scope="col" class="text-white lead">GRUPO</th>
                <th scope="col" class="text-white lead">CARRRERA</th>
                <th scope="col" class="text-white lead">HORARIO</th>
                <th scope="col" class="text-white lead">ACCIONES</th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="(asignacionn, index) in gruposDocentes" :key="index" class="table-light lead">
                <td>{{asignacionn.nombre}} {{asignacionn.primerApellido}} {{asignacionn.segundoApellido}}</td>
                <td>{{asignacionn.gradoGrupo}} {{asignacionn.letraGrupo}}</td>
                <td>{{asignacionn.nombreCarrera}}</td>
                <td>{{asignacionn.horaInicio}} - {{asignacionn.horaFin}}</td>
          
                <td>
                  <!-- <b-button variant="info" id="show-btn" @click="showModal('modal-vermas'); llenarObjetoDocente(docente)"><i class="material-icons">visibility</i></b-button> -->
                  <b-button variant="warning" id="show-btn" style="margin-right:20px;" @click="showModal('modal-modificarDG');llenarObjetoDocenteGrupo(asignacionn);listasGrupoProfesorModificar();"><i class="material-icons">edit</i></b-button>
                  <!-- <b-button variant="danger" id="show-btn" @click="eliminar(docente.id)"><i class="material-icons">delete</i></b-button> -->
                  <b-button variant="danger" id="show-btn" @click="eliminarGrupoProfesor(asignacionn.id)"><i class="material-icons">delete</i></b-button>
                </td>
                </tr>
            </tbody>
        </table>
        </div>
      </div>
<!-- MODAL MODIFICAR DOCENTE GRUOPO -->
      <b-modal ref="modal-modificarDG" hide-footer title="Modificar Asignación">
            <div class="d-block text-left">
                <h3></h3>
                <b-form @submit="modificarDocenteGrupo">
                    <div class="row form-group">
                        <div class="col">
                          <label for>Docente:</label>
                            <b-form-select v-model="objAsignacionDoceGru.idDocente" class="form-control">
                                <option v-for="docente in docentesGrupoM" :key="docente.id" :value="docente.id">
                                    {{docente.nombre}} {{docente.primerApellido}} {{docente.segundoApellido}} 
                                </option>
                            </b-form-select>
                            <label for>Grupo::</label>
                            <b-form-select v-model="objAsignacionDoceGru.idGrupo" class="form-control">
                                <option v-for="(grupo,index) in gruposM" :key="index" :value="grupo.id">
                                {{grupo.gradoGrupo}} {{grupo.letraGrupo}}
                            </option>
                            </b-form-select>
                        <label for>Horario:</label>
                        <b-form-select v-model="objAsignacionDoceGru.idHorario" class="form-control">
                            <option v-for="(horario,index) in horariosM" :key="index" :value="horario.id">
                                {{horario.horaInicio}} - {{horario.horaFin}}
                            </option>
                        </b-form-select>
                        </div>
                    </div>
                        <b-button type="submit" block variant="outline-success">Modificar</b-button>
                </b-form>
            </div>
            <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-modificarDG')">Cancelar</b-button>
        </b-modal>
<!-- MODAL MODIFICAR ASIGNA -->
         <b-modal ref="modal-modificarA" hide-footer title="Modificar Asignación">
            <div class="d-block text-left">
                <h3></h3>
                <b-form @submit="modificarAsignacion">
                    <div class="row form-group">
                        <div class="col">
                          <label for>Docente:</label>
                            <b-form-select v-model="objAsignacion.idDocente" class="form-control" required>
                                <option v-for="docente in listasDocentes" :key="docente.id" :value="docente.id">
                                    {{docente.nombre}} {{docente.primerApellido}} {{docente.segundoApellido}} 
                                </option>
                            </b-form-select>
                            <label for>Materia:</label>
                            <b-form-select v-model="objAsignacion.idMateria" class="form-control" required>
                                <option v-for="materia in materiasss" :key="materia.id" :value="materia.id">
                                    {{materia.nombreMateria}} 
                                </option>
                            </b-form-select>
                        </div>
                    </div>
                        <b-button type="submit" block variant="outline-success">Modificar</b-button>
                </b-form>
            </div>
            <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-modificarA')">Cancelar</b-button>
        </b-modal>
<!-- MODAL MODIFICAR -->
        <b-modal ref="modal-modificar" hide-footer title="Modificar Docente">
          <div class="d-block text-center">
              <form @submit="modificarDocente">
                  <div class="form-group">
                    <input type="text" class="form-control" v-model="objDocente.nombre" placeholder="Nombre(s)" />
                  </div>
                  <div class="row form-group">
                    <div class="col">
                      <input type="text" class="form-control" v-model="objDocente.primerApellido" placeholder="Primer Apellido" />
                    </div>
                    <div class="col">
                      <input type="text" class="form-control" v-model="objDocente.segundoApellido" placeholder="Segundo Apellido" />
                    </div>
                  </div>
                  <div class="form-group">
                    <label for>Género</label>
                    <select class="form-control" v-model="objDocente.sexo">
                      <option value="Femenino">Femenino</option>
                      <option value="Masculino">Masculino</option>
                      <option value="Otro">Otro</option>
                    </select>
                  </div>
                  <div class="form-group">
                    <input type="text" v-model="objDocente.curp" class="form-control" placeholder="CURP"/>
                    <small>
                      <a href="https://www.gob.mx/curp/">Consultar CURP</a>
                    </small>
                  </div>
                  <div class="row form-group">
                    <div class="col">
                      <input
                        type="email"
                        v-model="objDocente.correoInstitucional"
                        class="form-control"
                        placeholder="Correo Electrónico Institucional"
                      />
                    </div>
                    <div class="col">
                      <input type="email" v-model="objDocente.correoPersonal" class="form-control" placeholder="E-mail Personal"/>
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col">
                      <label for>Nivel Maximo de Estudios</label>
                      <select v-model="objDocente.nivelMaximo" class="form-control">
                        <option value="Preparatoria">Preparatoria</option>
                        <option value="Licenciatura">Licenciatura</option>
                        <option value="Ingenieria">Ingenieria</option>
                        <option value="Post-grado">Post-grado</option>
                        <option value="Maestria">Maestria</option>
                        <option value="Doctorado">Doctorado</option>
                      </select>
                    </div>
                    <div class="col">
                      <label for>Cedula Profesional</label>
                      <input v-model="objDocente.cedula" type="text" class="form-control" name id />
                    </div>
                  </div>
                  <div class="form-group">
                    <input type="text" class="form-control" v-model="objDocente.titulo" placeholder="Título Academico" />
                  </div>
                  <div class="form-group">
                    <label for>Semblanza</label>
                    <textarea name class="form-control" v-model="objDocente.semblanza" cols="10" rows="5"></textarea>
                  </div>
                  <div class="row form-group">
                    <div class="col">
                      <label for>Tipo de Horario</label>
                      <select v-model="objDocente.tiempoTrabajadorId" class="form-control">
                        <option
                        v-for="tipoHorario in listas.response.listaTiempo"
                        :key="tipoHorario.id"
                        :value="tipoHorario.id">
                        {{tipoHorario.nombreTiempo}}
                        </option>
                      </select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col">
                        <label for>Teléfono de casa</label>
                        <input class="form-control" type="text" placeholder="(777) 123-45-67" v-model="objDocente.telefonoCasa"/>
                    </div>
                    <div class="col">
                        <label for>Teléfono movil</label>
                        <input class="form-control" type="text" placeholder="(777) 123-45-67" v-model="objDocente.telefonoMovil"/>
                    </div>
                  </div>
                    <b-button  type="submit" variant="outline-success">Modificar</b-button>
                </form>
          </div>
          <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-modificar')">Cerrar</b-button>
        </b-modal>
<!-- MODAL REGISTRAR -->
        <b-modal ref="modal-registrar" hide-footer title="Registrar Docente" size="lg">
          <div class="d-block text-center">
            <b-form @submit="registrarDocente">
              <!--nombre-->
              <div class="form-group">
                <b-form-input type="text" class="form-control" v-model="nombre" placeholder="Nombre(s)" required :state="nameValid" />
                <b-form-invalid-feedback>Ingresa al menos 4 letras</b-form-invalid-feedback>
              </div>

              <!--Apellidos-->
              <div class="row form-group">
                <div class="col">
                  <b-form-input type="text" class="form-control" v-model="primerApellido" placeholder="Primer Apellido" :state="firstNameValid" required />
                    <b-form-invalid-feedback :state="firstNameValid">
                        Ingresa al menos 4 letras. 
                    </b-form-invalid-feedback>
                </div>
                <div class="col">
                  <b-form-input type="text" class="form-control" v-model="segundoApellido" placeholder="Segundo Apellido" :state="secondNameValid" required />
                    <b-form-invalid-feedback :state="firstNameValid">
                        Ingresa al menos 4 letras. 
                    </b-form-invalid-feedback>
                </div>
              </div>

              <!--Genero-->
              <div class="form-group">
                <label for>Género</label>
                <b-form-select class="form-control" v-model="genero" required :state="gengerValid">
                  <option value="Femenino">Femenino</option>
                  <option value="Masculino">Masculino</option>
                  <option value="Otro">Otro</option>
                </b-form-select>
                <b-form-invalid-feedback :state="firstNameValid">
                  Seleccione una opcion.
                </b-form-invalid-feedback>
              </div>

              <!--curp-->
              <div class="form-group">
                <b-form-input type="text" v-model="curp" class="form-control" placeholder="CURP" required @keyup="limitar" :state="curpValid"/>
                    <b-form-invalid-feedback :state="curpValid">
                        Ingresa tu CURP, 18 dígitos.  
                    </b-form-invalid-feedback>
                <small>
                  <a href="https://www.gob.mx/curp/" target="_blank">Consultar CURP</a>
                </small>
              </div>

              <!--correos-->
              <div class="row form-group">
                <div class="col">
                  <input
                    type="email"
                    v-model="correoInstitucional"
                    class="form-control"
                    placeholder="Correo Electrónico Institucional"
                    required
                  />
                  <b-form-text>
                    Verifica el formato: ejemplo@utez.edu.mx
                  </b-form-text>
                </div>
                <div class="col">
                  <input type="email" v-model="correoPersonal" class="form-control" placeholder="E-mail Personal" required/>
                  <b-form-text>
                    Verifica el formato: ejemplo@utez.edu.mx
                  </b-form-text>
                </div>
              </div>

              <!--nivel-->
              <div class="row form-group">
                <div class="col">
                  <label for>Nivel Maximo de Estudios</label>
                  <b-form-select v-model="nivelMax" class="form-control" required :state="nivelValid">
                    <option value="Preparatoria">Preparatoria</option>
                    <option value="Licenciatura">Licenciatura</option>
                    <option value="Ingenieria">Ingenieria</option>
                    <option value="Post-grado">Post-grado</option>
                    <option value="Maestria">Maestria</option>
                    <option value="Doctorado">Doctorado</option>
                  </b-form-select>
                  <b-form-invalid-feedback :state="nivelValid">
                    Seleccione una opcion  
                  </b-form-invalid-feedback>
                </div>
                <!--cedula-->
                <div class="col">
                  <label for>Cedula Profesional</label>
                  <b-form-input v-model="cedula" type="text" class="form-control" @keyup="limitCed" required :state="cedulaValid" />
                  <b-form-invalid-feedback>Ingresa tu Cédula, 8 dígitos.</b-form-invalid-feedback>
                </div>
              </div>

              <!--titulo-->
              <div class="form-group">
                <b-form-input type="text" class="form-control" v-model="titulo" placeholder="Título Academico" required :state="tituloValid" />
                <b-form-invalid-feedback :state="tituloValid">
                  Ingrese al menos 3 letras 
                </b-form-invalid-feedback>
              </div>

              <!--Semblanza-->
              <div class="form-group">
                <label for>Semblanza</label>
                <b-form-textarea name class="form-control" v-model="semblanza" cols="10" rows="5" required :state="semblanzaValid"></b-form-textarea>
                <b-form-invalid-feedback :state="semblanzaValid">
                  Describete en al menos 10 palabras. 
                </b-form-invalid-feedback>
              </div>
              <!--horario-->
              <div class="row form-group">
                <div class="col">
                  <label for>Tipo de Horario</label>
                  <b-form-select v-model="tipoHorario" class="form-control" required :state="tiempoValid">
                    <option
                    v-for="tipoHorario in listas.response.listaTiempo"
                    :key="tipoHorario.id"
                    :value="tipoHorario.id">
                    {{tipoHorario.nombreTiempo}}
                    </option>
                  </b-form-select>
                  <b-form-invalid-feedback :state="tiempoValid">
                  Seleccione una opcion.
                </b-form-invalid-feedback>
                </div>
              </div>
              <!--telefonos-->
              <div class="row form-group">
                <div class="col">
                    <label for>Teléfono de casa</label>
                    <b-form-input class="form-control" type="text" placeholder="(777) 123-45-67" v-model="telCasa" required :state="telCasaValid"/>
                    <b-form-invalid-feedback :state="telCasaValid">
                      Ingrese 10 dígitos.
                    </b-form-invalid-feedback>
                </div>
                <div class="col">
                    <label for>Teléfono movil</label>
                    <b-form-input class="form-control" type="text" placeholder="(777) 123-45-67" v-model="telMovil" required :state="telefonoMovil"/>
                    <b-form-invalid-feedback :state="telefonoMovil">
                      Ingrese 10 dígitos.
                    </b-form-invalid-feedback>
                </div>
              </div>
                    <b-button  block type="submit" variant="outline-success">Registrar</b-button>
            </b-form>
          </div>
          <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-registrar')">Cerrar</b-button>
        </b-modal>
<!-- MODAL VER MÁS -->
        <b-modal ref="modal-vermas" hide-footer title="Información Completa">
          <div class="d-block text-left">
              <p><strong>Nombre:</strong> {{objDocente.nombre}} {{objDocente.primerApellido}} {{objDocente.segundoApellido}}</p>
              <p> <strong>Cedula:</strong> {{objDocente.cedula}}</p>
              <p> <strong>Correo institucional:</strong> {{objDocente.correoInstitucional}}</p>
              <p> <strong>Correo personal:</strong> {{objDocente.correoPersonal}}</p>
              <p><strong>CURP:</strong> {{objDocente.curp}}</p>
              <div v-for="division in listas.response.listaDivicion" :key="division.id">
                <p v-show="division.id == objDocente.divicionTrabajadorId">
                    <strong>División académica: </strong>{{division.nombreDivicion}}
                </p>
            </div>
            <p><strong>Nivel máximo de estudios: </strong>{{objDocente.nivelMaximo}}</p>
            <div v-for="tiempo in listas.response.listaTiempo" :key="tiempo.id">
                <p v-show="tiempo.id == objDocente.tiempoTrabajadorId">
                    <strong>Tiempo: </strong>{{tiempo.nombreTiempo}}
                </p>
              </div>
              <p><strong>Semblanza:</strong> {{objDocente.semblanza}}</p>
              <p><strong>Sexo:</strong> {{objDocente.sexo}}</p>
              <p><strong>Telefono Casa:</strong> {{objDocente.telefonoCasa}}</p>
              <p><strong>Telefono Celular:</strong> {{objDocente.telefonoMovil}}</p>     
          </div>
          <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-vermas')">Cerrar</b-button>
        </b-modal>
  </section>
</template>
<script>
import axios from "axios";
import {server} from '../../store'
import { functions } from "../../functionsGolbals";

export default {
  mixins: [functions],
    data(){
        return{
          docenteIdGrupo:null,
          horarioId:null,
          idGrupoGrupo:null,
          carreraIdGrupo:null,
          user:[],
          docentes:[],
          objDocente:[],
          listas:[],
          output: null,
          nombre: '',
          primerApellido: '',
          segundoApellido: '',
          genero: '',
          curp: '',
          correoInstitucional: '',
          correoPersonal: '',
          nivelMax: '',
          cedula: '',
          titulo: '',
          semblanza: '',
          division: '',
          tipoHorario: '',
          telCasa: '',
          telMovil: '',
          divisionId:null,
          asignaciones:[],
          listasRegistro:[],
          carreras:[],
          carreraId:null,
          docenteId:null,
          materiaId:null,
          listasMaterias:[],
          listasDocentes:[],
          objAsignacion:[],
          materiasPorCarrera:[],
          materiasss:[],
          listasGrupoProfesorA:[],
          listasGrupoProfesorAM:[],
          horarios:[],
          docentesGrupo:[],
          grupos:[],
          horariosM:[],
          docentesGrupoM:[],
          gruposM:[],
          gruposDocentes:[],
          objAsignacionDoceGru:[]
        }
    },
    computed:{
      nameValid(){
            if(this.nombre.length == 0)return null;
            if(this.nombre.length > 3) return true;
            else return false; 
        },
        firstNameValid(){
            if(this.primerApellido.length == 0) return null;
            if(this.primerApellido.length > 3) return true;
            else return false;
        },
        secondNameValid(){
            if(this.segundoApellido.length == 0)return null;
            if(this.segundoApellido.length > 3) return true;
            else return false;
        },
        gengerValid(){
            if(this.genero == '')return null;
            else return true;
        },
        curpValid(){
            if(this.curp.length == 0)return null;
            if(this.curp.length == 18)return true;
            else return false;
        },
        nivelValid(){
            if(this.nivelMax == '')return null;
            else return true;
        },
        cedulaValid(){
            if(this.cedula.length == 0) return null;
            if(this.cedula.length == 8)return true;
            else return false;
        },
        tituloValid(){
            if(this.titulo.length == 0)return null;
            if(this.titulo.length > 2)return true;
            else return false;
        },
        semblanzaValid(){
            if(this.semblanza.length == 0) return null;
            if(this.semblanza.length > 10) return true;
            else return false;
        },
        diviValid(){
            if(this.division == '')return null;
            else return true;
        },
        tiempoValid(){
            if(this.tipoHorario == '')return null;
            else return true;
        },
        telCasaValid(){
            if(this.telCasa.length == 0)return null;
            if(this.telCasa.length == 10) return true;
            else return false;
        },
        telefonoMovil(){
            if(this.telMovil.length == 0)return null;
            if(this.telMovil.length == 10) return true;
            else return false;
        }
    },
    mounted(){
      if(localStorage.getItem('usuario') == null){
          this.$router.push("/login");
      }else{
          this.user = JSON.parse(localStorage.getItem('usuario'));
      }
      this.divisionId = this.user.divicionTrabajadorId;
      this.obtenerDocentes();
      this.listasParaRegistrar();
      this.obtenerListas();
      this.obtenerCarreras();
      this.obtenerAsginaciones();
      this.obtenerGrupoProfesores();
    },
    methods:{
      eliminarGrupoProfesor(id){
          let currentObj = this;
            axios.post(`${server.baseURL}/api/grupo-profesor/eliminar`, {
                    grupo_profesor: {
                        id: id
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerGrupoProfesores();
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.alertError(currentObj.output.response.message);
                });
      },
      obtenerGrupoProfesores(){
          axios
              .get(`${server.baseURL}/api/grupo-profesor/lista`)
              .then(data => (this.gruposDocentes = data.data));
      },
      pasarListasGrupo(){
        this.horarios = this.listasGrupoProfesorA.response.horarios;
        this.docentesGrupo = this.listasGrupoProfesorA.response.listaDocentes;
        this.grupos = this.listasGrupoProfesorA.response.listaGrupos;
      },
      pasarListasGrupoM(){
        this.horariosM = this.listasGrupoProfesorAM.response.horarios;
        this.docentesGrupoM = this.listasGrupoProfesorAM.response.listaDocentes;
        this.gruposM = this.listasGrupoProfesorAM.response.listaGrupos;
      },
      listasGrupoProfesor(){
        let objeto = this;
            axios
              .post(`${server.baseURL}/api/grupo-profesor/listasParaRegistro`, {
                carrera: {
                  id: this.carreraIdGrupo
                }
              })
              .then(function(response) {
                objeto.listasGrupoProfesorA = response.data;
                objeto.pasarListasGrupo();
              })
              .catch(function(error) {
                objeto.output = error;
              });
      },
      listasGrupoProfesorModificar(){
        // alert("hia");
        let objeto = this;
            axios
              .post(`${server.baseURL}/api/grupo-profesor/listasParaRegistro`, {
                carrera: {
                  id: this.objAsignacionDoceGru.idCarrera
                }
              })
              .then(function(response) {
                objeto.listasGrupoProfesorAM = response.data;
                objeto.pasarListasGrupoM();
              })
              .catch(function(error) {
                objeto.output = error;
              });
      },
      modificarDocenteGrupo(e){
        e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/grupo-profesor/modificar`, {
                    modificar: {
                        id: this.objAsignacionDoceGru.id,
                        idGrupo: this.objAsignacionDoceGru.idGrupo,
                        idDocente: this.objAsignacionDoceGru.idDocente,
                        idHorario: this.objAsignacionDoceGru.idHorario
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerGrupoProfesores();
                    currentObj.hideModal('modal-modificarDG');
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.obtenerAsginaciones();
                    currentObj.hideModal('modal-modificarDG');
                    currentObj.alertError(currentObj.output.response.message);
                });   
      },
      modificarAsignacion(e){
        e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/imparte-materias/modificar`, {
                    modificar: {
                        id: this.objAsignacion.id,
                        idTrabajador: this.objAsignacion.idDocente,
                        idMateria: this.objAsignacion.idMateria
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerAsginaciones();
                    currentObj.hideModal('modal-modificarA');
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.obtenerAsginaciones();
                    currentObj.hideModal('modal-modificarA');
                    currentObj.alertError(currentObj.output.response.message);
                });   
      },
      llenarObjAsignacion: function (asignacion) {
            this.objAsignacion = asignacion
      },
      llenarObjetoDocenteGrupo: function (asignacion){
        this.objAsignacionDoceGru = asignacion
      },
      pasarListas(){
            this.materiasss = this.materiasPorCarrera.response.listaMaterias;
            this.listasDocentes = this.listasRegistro.response.listaProfesores

      },
      asignacionDocenteGrupo(e){
         e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/grupo-profesor/registro`, {
                    registro: {
                        idGrupo: this.idGrupoGrupo,
                        idDocente: this.docenteIdGrupo,
                        idHorario: this.horarioId
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerGrupoProfesores();
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.obtenerAsignaciones();
                    currentObj.alertError(currentObj.output.response.message);
                });
      },
      registrarAsignacion(e){
        e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/imparte-materias/registro`, {
                    registro: {
                        idTrabajador: this.materiaId,
                        idMateria: this.docenteId,
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerAsginaciones();
                    currentObj.hideModal('modal-asignar');
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.obtenerAsignaciones();
                    currentObj.hideModal('modal-asignar');
                    currentObj.alertError(currentObj.output.response.message);
                });
      },
      listasParaRegistrar(){
        let objeto = this;
            axios
              .post(`${server.baseURL}/api/imparte-materias/listasParaRegistro`, {
                carrera: {
                  id: this.user.divicionTrabajadorId
                }
              })
              .then(function(response) {
                objeto.listasRegistro = response.data;
                objeto.pasarListas();
              })
              .catch(function(error) {
                objeto.output = error;
              });
      },
      listasMateriass(){
        let objeto = this;
            axios
              .post(`${server.baseURL}/api/imparte-materias/listaMaterias`, {
                carrera: {
                  id: this.carreraId
                }
              })
              .then(function(response) {
                objeto.materiasPorCarrera = response.data;
                objeto.pasarListas();
              })
              .catch(function(error) {
                objeto.output = error;
              });
      },
      obtenerListas(){
          axios
                .get(`${server.baseURL}/api/trabajador/listas`)
                .then(data => (this.listas = data.data));
      },
      obtenerDocentes(){
            let objeto = this;
            axios
              .post(`${server.baseURL}/api/trabajador/listaDocentes`, {
                divicion: {
                  id: this.divisionId
                }
              })
              .then(function(response) {
                objeto.docentes = response.data;
              })
              .catch(function(error) {
                objeto.output = error;
              });
      },
      obtenerCarreras(){
            let objeto = this;
            axios
              .post(`${server.baseURL}/api/imparte-materias/carreras`, {
                division: {
                  id: this.divisionId
                }
              })
              .then(function(response) {
                objeto.carreras = response.data;
              })
              .catch(function(error) {
                objeto.output = error;
              });
        },
      obtenerAsginaciones(){
        axios
                .get(`${server.baseURL}/api/imparte-materias/lista`)
                .then(data => (this.asignaciones = data.data));
      },
      llenarObjetoDocente: function (docente) {
            this.objDocente = docente
      },
      registrarDocente(e){
          e.preventDefault();
          let currentObj = this;
          axios.post(`${server.baseURL}/api/trabajador/registro`, {
            trabajador:{
              nombre: this.nombre,
              primerApellido: this.primerApellido,
              segundoApellido: this.segundoApellido,
              correoInstitucional: this.correoInstitucional,
              correoPersonal: this.correoPersonal,
              cedula: this.cedula,
              nivelMaximo: this.nivelMax,
              titulo: this.titulo,
              telefonoCasa: this.telCasa,
              telefonoMovil: this.telMovil,
              curp: this.curp,
              semblanza: this.semblanza,
              sexo: this.genero,
              tiempoId: this.tipoHorario,
              divicionId: this.divisionId,
              rol: 3
            }
          })
          .then(function (response) {
            currentObj.output = response.data;
            currentObj.obtenerDocentes();
            currentObj.hideModal('modal-registrar');  
            currentObj.alertSuccess(currentObj.output.response.message);   
          })
          .catch(function (error) {
            currentObj.output = error;
            currentObj.hideModal('modal-registrar');  
            currentObj.alertError(currentObj.output.response.message); 
          });
      },
      modificarDocente(e) {
        e.preventDefault();
        let currentObj = this;
          axios.post(`${server.baseURL}/api/trabajador/modificacion`, {
            trabajador: {
              id: this.objDocente.id,
              nombre: this.objDocente.nombre,
              primerApellido: this.objDocente.primerApellido,
              segundoApellido: this.objDocente.segundoApellido,
              correoInstitucional: this.objDocente.correoInstitucional,
              correoPersonal: this.objDocente.correoPersonal,
              cedula: this.objDocente.cedula,
              nivelMaximo: this.objDocente.nivelMaximo,
              titulo: this.objDocente.titulo,
              telefonoCasa: this.objDocente.telefonoCasa,
              telefonoMovil: this.objDocente.telefonoMovil,
              estado: "activo",
              semblanza: this.objDocente.semblanza,
              sexo: this.objDocente.sexo,
              tiempoTrabajadorId: this.objDocente.tiempoTrabajadorId,
              divicionTrabajadorId : this.user.divicionTrabajadorId
            }
          })
          .then(function (response) {
            currentObj.output = response.data;
            currentObj.obtenerDocentes();
            currentObj.obtenerAsginaciones();
            currentObj.hideModal('modal-modificar');  
            currentObj.alertSuccess(currentObj.output.response.message);
          })
          .catch(function (error) {
            currentObj.output = error;
            currentObj.obtenerDocentes();
            currentObj.hideModal('modal-modificar');  
            currentObj.alertError(currentObj.output.response.message); 
          });
      },
      goBack(){
        window.history.go(-1);
      },
      eliminar(id){
            let currentObj = this;
            axios.post(`${server.baseURL}/api/trabajador/eliminar`, {
                    eliminar: {
                        id: id
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerDocentes();
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
      eliminarAsignacion(id){
          let currentObj = this;
            axios.post(`${server.baseURL}/api/imparte-materias/eliminar`, {
                    eliminar: {
                        id: id
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerAsginaciones();
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.alertError(currentObj.output.response.message);
                });
        },    
        limitar(){         
            if(this.curp.length >= 18){
                this.curp=this.curp.substring(0,18);        
            }     
        },
        limitCed(){
            if(this.cedula.length >= 8){
                this.cedula=this.cedula.substring(0,8);        
            }
        }
    }
}
</script>